#include <iostream>
#include <cmath>
#include <bits/stdc++.h>
using namespace std;

int main()
{
    int i=0,N,o,a,b,ab,n,O,A,B,AB;
    string m;
    cin>>N;
    cin>>o>>a>>b>>ab;

    while(i!=N)
    {
    cin>>m>>n;
    if(m=="O")
    {
        if(o-n>=0)
            o=o-n;
    }
    else if(m=="A")
    {
        if(a-n>=0)
            a=a-n;

        else
        {
            a=a-n;
            o=o-abs(a);
            a=0;
        }
    }
    else if(m=="B")
    {
        if(b-n>=0)
            b=b-n;
        else
        {
            b=b-n;
            o=o-abs(b);
            b=0;
        }
    }
    else if(m=="AB")
    {
        if(ab-n>=0)
            ab=ab-n;
        else
        {
            ab=ab-n;
            if(o-abs(ab)>=0)
            {
                o=o-abs(ab);
                ab=0;
            }
            else if(a-abs(ab)>=0)
            {
                a=a-ab;
            }
            else
            {
                if(b-abs(ab)>=0)
                    b=b-abs(ab);
            }
        }
    }
    i++;
    }
    if(o>=0&&a>=0&&b>=0&&ab>=0)
    {
        cout<<"moguce"<<endl;
    }
    else
        cout<<"nemoguce"<<endl;
    return 0;
}